package info.bukova.isspst.filters;

import static info.bukova.isspst.StringUtils.nullStr;
import info.bukova.isspst.data.MUnit;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.Matcher;
import org.hamcrest.TypeSafeMatcher;

public class MUnitFilter implements Filter<MUnit> {
	
	private MUnit condMUnit;
	
	public MUnitFilter(MUnit condMUnit) {
		this.condMUnit = condMUnit;
	}

	private static class MUnitMatcher extends TypeSafeMatcher<MUnit> {

		private MUnit condMUnit;
		
		public MUnitMatcher(MUnit cond) {
			this.condMUnit = cond;
		}
		
		@Override
		public void describeTo(Description desc) {
			desc.appendText("munits matches");
		}

		@Override
		public boolean matchesSafely(MUnit item) {
			return nullStr(item.getCode()).toLowerCase().contains(nullStr(condMUnit.getCode()).toLowerCase()) 
					&& nullStr(item.getName()).toLowerCase().contains(nullStr(condMUnit.getName()).toLowerCase())
					&& nullStr(item.getDescription()).toLowerCase().contains(nullStr(condMUnit.getDescription()).toLowerCase());
		}
		
		@Factory
		public static Matcher<MUnit> matchMUnit(MUnit munit) {
			return new MUnitMatcher(munit);
		}
	}
	
	@Override
	public MUnitMatcher matcher() {
		return new MUnitMatcher(condMUnit);
	}

	@Override
	public String queryString() {
		// TODO query string
		return "";
	}

}
